import player, board
import numpy as np

class game:
    allplayers = []
    mana_actions_avail = [True, True, True, True, True, True]
    def __init__(self):
        game.p1 = player.player("fairies")
        game.allplayers.append(game.p1)
        game.p2 = player.player("sunworshippers")
        game.allplayers.append(game.p2)
        game.board = board.board()
        game.round = 0

    #what happens if a player gains power
    def gainpower(self, p, amount):
        a = min(p.mana1, amount)
        amount -= a
        p.mana1 -= a
        p.mana2 += a
        a = min(p.mana2, amount)
        amount -= a
        p.mana2 -= a
        p.mana3 += a

    def paypower(self, p, amount):
        p.mana3 -= amount
        p.mana1 += amount

    def print_mana(self, p):
        print(str(p.mana1) + ", " + str(p.mana2) + ", " + str(p.mana3))

    #dig tile
    def dig(self, p, board, row, col):
        digcolor = p.color
        tilecolor = board.tiles[row][col].color
        digsteps = min (abs(digcolor-tilecolor), abs(abs(digcolor-tilecolor)-5))
        p.money -= 6*digsteps
        board.tiles[row][col].color = digcolor
        print("dig on [" + str(row) + ", " + str(col) + "]")
        game.printboard(self)

    def dig_free1(self, p, board, row, col):
        digcolor = p.color
        tilecolor = board.tiles[row][col].color
        digsteps = min (abs(digcolor-tilecolor), abs(abs(digcolor-tilecolor)-5))
        if digsteps > 0:
            return False
        p.money -= 6*(digsteps-1)
        board.tiles[row][col].color = digcolor 
        print("dig_free on [" + str(row) + ", " + str(col) + "]")
        game.printboard(self)

    def dig_free2(self, p, board, row, col):
        digcolor = p.color
        tilecolor = board.tiles[row][col].color
        digsteps = min (abs(digcolor-tilecolor), abs(abs(digcolor-tilecolor)-5))
        if digsteps > 1:
            return False
        board.tiles[row][col].color = digcolor
        print("dig_free2 on [" + str(row) + ", " + str(col) + "]")
        game.printboard(self)

    #build house
    def build_house(self, p, board, row, col):
        if board.tiles[row][col].color != p.color or p.houses == 0:
            return False
        board.tiles[row][col].building = 1
        board.tiles[row][col].player = p
        print("build house on [" + str(row)+ ", " + str(col) + "]")
        game.printboard(self)
        p.moneyinc += p.houses_income[0][8-p.houses]
        p.powerinc += p.houses_income[1][8-p.houses]
        p.houses -= 1
        p.money -= 4

    def build_house_free(self, p, board, row, col):
        if board.tiles[row][col].color != p.color or p.houses == 0:
            return False
        board.tiles[row][col].building = 1
        board.tiles[row][col].player = p
        print("build house on [" + str(row)+ ", " + str(col) + "]")
        game.printboard(self)
        p.moneyinc += p.houses_income[0][8-p.houses]
        p.powerinc += p.houses_income[1][8-p.houses]
        p.houses -= 1

    def dig_build(self, p, board, row, col):
        game.dig(self, p, board, row, col)
        game.build_house(self, p, board, row, col)
        game.leech(self, p, board, row, col)

    #TODO upgrade
    def upgrade_house(self, p, board, row, col):
        board.tiles[row][col].building = 2
        print("upgrade to tp on [" + str(row)+ ", " + str(col) + "]")
        game.printboard(self)
        p.moneyinc += p.tp_income[0][4-p.tradep]
        p.powerinc += p.tp_income[1][4-p.tradep]
        p.houses += 1
        p.moneyinc -= p.houses_income[0][8-p.houses]
        p.powerinc -= p.houses_income[1][8-p.houses]
        p.tradep -= 1
        #TODO neighbors? cost 10 if not
        costreduction = False
        for k in board.tiles[row][col].neighbors:
            if board.tiles[k[0]][k[1]].building != 0 and board.tiles[k[0]][k[1]].color != p.color:
                costreduction = True
                break
        if costreduction:
            p.money -= 7
        else: p.money -= 10
        game.leech(self, p, board, row, col)

    def upgrade_tp1(self, p, board, row, col):
        board.tiles[row][col].building = 3
        print("upgrade to tp1 on [" + str(row)+ ", " + str(col) + "]")
        game.printboard(self)
        p.moneyinc += p.sh1_income[0]
        p.powerinc += p.sh1_income[1]
        p.tradep += 1
        p.moneyinc -= p.houses_income[0][4-p.tradep]
        p.powerinc -= p.houses_income[1][4-p.tradep]
        p.strongh1 -= 1
        p.money -= 14
        #TODO faction specifics
        game.leech(self, p, board, row, col)

    def upgrade_tp2(self, p, board, row, col):
        board.tiles[row][col].building = 3
        print("upgrade to tp1 on [" + str(row)+ ", " + str(col) + "]")
        game.printboard(self)
        p.tradep += 1
        p.moneyinc -= p.houses_income[0][4-p.tradep]
        p.powerinc -= p.houses_income[1][4-p.tradep]
        p.strongh2 -= 1
        p.money -= 14
        #TODO faction specifics
        game.leech(self, p, board, row, col)

    #Upgrade sailing
    def upgrade_sailing(self, p):
        if p.money < 8 or p.sailing == 3:
            return False
        print ("upgrade sailing")
        p.money -= 8
        p.sailing += 1
        p.vp += p.sailing + 1

    def upgrade_sailing_free(self, p):
        if p.sailing == 3:
            return False
        p.sailing += 1
        p.vp += p.sailing + 1

    #TODO mana actions
    def mana_bridge3(self, p, row1, col1, row2, col2):
        if p.mana3 < 3:
            return False
        game.paypower(self, p, 3)    
        game.build_bridge(self, row1, col1, row2, col2)
        game.mana_actions_avail[0] = False   

    def mana_bridge4(self, p, row1, col1, row2, col2):
        if p.mana3 < 4:
            return False
        game.paypower(self, p, 4)
        game.build_bridge(self, row1, col1, row2, col2)
        game.mana_actions_avail[1] = False   
        
    def mana_sailing(self, p):
        if p.mana3 < 4 or p.sailing == 3:
            return False
        game.paypower(self, p, 4)       
        p.sailing += 1
        p.vp += p.sailing + 1
        game.mana_actions_avail[2] = False
    
    def mana_money(self, p):
        if p.mana3 < 4:
            return False
        game.paypower(self, p, 4)       
        p.money += 7
        game.mana_actions_avail[3] = False


    def mana_dig(self, p, row, col):
        if p.mana3 < 4:
            return False
        game.paypower(self, p, 4)       
        game.dig_free1(self, p, game.board, row, col)
        game.mana_actions_avail[4] = False

    def mana_dig2(self, p, row, col):
        if p.mana3 < 6:
            return False
        game.paypower(self, p, 6)       
        game.dig_free2(self, p, game.board, row, col)
        game.mana_actions_avail[5] = False

    #TODO build bridges
    def build_bridge(self, row1, col1, row2, col2):
        game.board.tiles[row1][col1].build_bridge(row2, col2) # type: ignore
        game.board.tiles[row2][col2].build_bridge(row1, col1) # type: ignore

    #TODO special actions :/

    #TODO passing

    #TODO founding a city (check at end of build/upgrade - seabears are shit here)

    #TODO 2player variants?

    #TODO leech
    def leech(self, p, board, row, col):
        for k in board.tiles[row][col].neighbors:
            if board.tiles[k[0]][k[1]].building != 0 and board.tiles[k[0]][k[1]].color != p.color:
                print("add power " + board.tiles[k[0]][k[1]].player.faction)
                game.gainpower(self, board.tiles[k[0]][k[1]].player, 1)

    #what happens if a round ends
    #TODO round end upkeep (passing tiles,)
    def round_end(self):
        if all(p.passed == True for p in game.allplayers):
            print ("round " + str(game.round) + " end")
            game.round += 1
            game.mana_actions_avail = [True, True, True, True, True, True]
            if game.round == 6:
                print ("game end")
                #TODO vp for biggest network
                for p in game.allplayers:
                    p.money += p.mana3
                    p.vp += int(p.money/3)
                    print (p.faction + " " + str(p.vp))
            else:
                for p in game.allplayers:
                    p.money += p.moneyinc
                    game.gainpower(self, p, p.powerinc)

    #TODO available actions

    #helper function, not necessary for final code
    def printboard(self):
        game.board.print_board()

    def print_players(self):
        for p in game.allplayers:
            p.print_player()

    def print_mana_actions(self):
        print(game.mana_actions_avail)